# include <Arduino.h>
# include <Frequency.h>

enum { TFT_CS = 10, TFT_RST = 9, TFT_DC = 8 };

Adafruit_ST7735 tft = Adafruit_ST7735( TFT_CS,  TFT_DC, TFT_RST );

Frequency freq( 3, A2, A3, tft );

ISR( PCINT1_vect )
{
  freq.rotated();
}

ISR( PCINT2_vect )
{
  freq.pushed();
}

void
setup( void )
{
  Serial.begin( 115200 );
  Serial.println( "Rotate to digit you want to change." );
  Serial.println( "Push knob down to select the digit to change." );
  Serial.println( "Rotate the knob to change the digit." );
  Serial.println( "Push the knob down again to select a new digit." );
  delay( 1000 );

  freq.init();
  freq.value( 1000 );
  freq.show_frequency();
}

unsigned long int old_freq = 0;

void loop( void )
{
  if( freq.value() != old_freq )
  {
    Serial.print( "Setting frequency to " );
    Serial.println( freq.value() );
    old_freq = freq.value();
  }
}
