# include <Arduino.h>
# include <EF_AD9850.h>
# include <Frequency.h>

enum { CLK = 7, FQUP = 6, RESET = 5, DATA = 4 };
EF_AD9850 AD9850( CLK, FQUP, RESET, DATA );

enum { TFT_CS = 10, TFT_RST = 9, TFT_DC = 8 };

Adafruit_ST7735 tft = Adafruit_ST7735( TFT_CS,  TFT_DC, TFT_RST );

Frequency freq( 3, A2, A3, tft );

ISR( PCINT1_vect )
{
  freq.rotated();
}

ISR( PCINT2_vect )
{
  freq.pushed();
}

void
setup( void )
{
  freq.init();
  freq.value( 1000 );
  freq.show_frequency();

  AD9850.reset();
  AD9850.wr_serial( 0, freq.value() );
}

unsigned long int old_freq = 0;

void loop( void )
{
  if( freq.value() != old_freq )
  {
    AD9850.wr_serial( 0, freq.value() );
    old_freq = freq.value();
  }
}

